<?php
	if(!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			membersOnly
		*
		* @CMS required		PluXml 
		* @page				admin.php
		* @version			1.0
		* @date				2025-01-01
		* @author 			Gcyrillus
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/	
	# Control du token du formulaire
	plxToken::validateFormToken($_POST);
	
	# Liste des langues disponibles et prises en charge par le plugin
	$aLangs = array($plxAdmin->aConf['default_lang']);	
	# init vars / remove unecessary
	
	# initialisation des variables propres à chaque lanque
	$langs = array();
	foreach($aLangs as $lang) {
		# chargement de chaque fichier de langue
		$langs[$lang] = $plxPlugin->loadLang(PLX_PLUGINS.'excludeFromVisitors/lang/'.$lang.'.php');
		$var[$lang]['mnuName'] =  $plxPlugin->getParam('mnuName_'.$lang)=='' ? $plxPlugin->getLang('L_DEFAULT_MENU_NAME') : $plxPlugin->getParam('mnuName_'.$lang);
	}	
	
	# liste des pages statiques et filtres
	$filter=array();
	$stats = $plxAdmin->aStats;
	$statsPage="";
	if(trim($plxPlugin->statiques) !='') {
		$filter = json_decode($plxPlugin->statiques,true);
	}	
	foreach($plxAdmin->aStats as $stat_num => $stat_info) {
		$checked="";
		if(is_array($filter) && in_array($stat_num,$filter)) $checked=" checked ";
		$statsPage .='
		<p>
		<label for="stat-'.$stat_num.'"> N°<b>'.$stat_num.'</b> - '. $stat_info['name'].'</label>
		<input type="checkbox" id ="stat-'.$stat_num.'" name="statiquesPages[]" '.$checked.' value="'.$stat_num.'" data-group="'.$stat_info['group'].'">
		</p>';                                
		
	}
	
	
	
	# liste des articles et filtres
	$filter=array();
	$arts= $plxAdmin->plxGlob_arts->aFiles;	
	$articlePage="";
	if(trim($plxPlugin->articles) !='') {
		$filter = json_decode($plxPlugin->articles,true);	
		foreach($plxAdmin->plxGlob_arts->aFiles as $art_num => $filename) {
			$checked="";
			if(is_array($filter) && in_array($art_num,$filter)) $checked=" checked ";
			$art = $plxAdmin->parseArticle(PLX_ROOT.'data/articles/'.$filename);
			$articlePage .='
			<p>
			<label for="art-'.$art_num.'">N°<b>'.$art_num.'</b> - '. $art['title'].'</label>
			<input type="checkbox" id ="art-'.$art_num.'" name="articles[]" '.$checked.' value="'.$art_num.'">
			</p>';                                
			
		}	
	}
	
	# liste des catégories et filtres
	$filter=array();
	$cats = $plxAdmin->aCats;	
	$categoriePage="";
	
	if(trim($plxPlugin->categories) !='') {
		$filter = json_decode($plxPlugin->categories,true);	
		foreach($plxAdmin->aCats as $cat_num => $infos) {
			$checked="";
			if(is_array($filter) && in_array($cat_num,$filter)) $checked=" checked ";
			$art = $plxAdmin->parseArticle(PLX_ROOT.'data/articles/'.$filename);
			$categoriePage .='
			<p>
			<label for="cat-'.$cat_num.'">N°<b>'.$cat_num.'</b> - '. $infos['name'].'</label>
			<input type="checkbox" id ="cat-'.$cat_num.'" name="categories[]" '.$checked.' value="'.$cat_num.'">
			</p>';                                
			
		}	
	}
	
	
	if(!empty($_POST)) {
		if(!isset($_POST['statiquesPages'])) $_POST['statiquesPages'] =array();
		$plxPlugin->setParam('statiques', json_encode($_POST['statiquesPages'],true),'cdata');
		if(!isset($_POST['articles'])) $_POST['articles']=array();
		$plxPlugin->setParam('articles', json_encode($_POST['articles'],true), 'cdata');
		if(!isset($_POST['categories'])) $_POST['categories'] = array();
		$plxPlugin->setParam('categories', json_encode($_POST['categories'],true), 'cdata');
		$plxPlugin->saveParams();
		header("Location: plugin.php?p=".basename(__DIR__));
		exit;
	}
	
?>
<link rel="stylesheet" href="<?php echo PLX_PLUGINS."excludeFromVisitors/css/tabs.css" ?>" media="all" />
<h2><?php $plxPlugin->lang("L_ADMIN") ?></h2>
<style>
	fieldset,details summary{all:revert}
	details .grid {
	max-width:100%;
	padding:0 1em;
	display:grid;
	grid-template-columns:repeat(auto-fit,minmax(12em,1fr));
	gap:.5em 1em;
	}
	details .grid p {
	display:flex;
	gap:.25em;
	max-width:100%;
	padding:0 0.25em;
	box-shadow:1px 1px;
	}
	details .grid p:has(:checked) {
	color:blue;
	}
	details .grid p label{
	flex:1
	}
</style>
<form action="plugin.php?p=<?= basename(__DIR__) ?>" method="post" >
	<h3><?php $plxPlugin->lang("L_SELECT_MEMBER_ACCESS") ?></h3>
	<fieldset id="group"><legend>Groupes Pages statiques</legend>		
		<details><summary>Afficher la liste.</summary>	
			<div class="grid">
			</div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_STATICS ?></legend>		
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div class="grid">
				<?= $statsPage ?>
			</div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_ARTICLES ?></legend>
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div class="grid">
				<?= $articlePage ?>
			</div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_CATEGORIES ?></legend>
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div class="grid">
				<?= $categoriePage ?>
			</div>
		</details>		
	</fieldset>
	
	<p class="in-action-bar">
		<?php echo plxToken::getTokenPostMethod() ?><br>
		<input type="submit" name="submit" value="<?= $plxPlugin->getLang('L_SAVE') ?>"/>
	</p>
</form>
<script>
	const group = document.querySelectorAll('form [data-group]');
	const fieldGroup = document.querySelector('#group div.grid');
	let groupArray={};
	for(i=0;group.length>i;i++){
		let key = group[i].dataset.group;
		if(key !=''  ) {
			
			if( typeof groupArray[key] !== 'undefined') {groupArray[key] =  groupArray[key] +'|'+group[i].getAttribute('id').slice(-3);}
			else groupArray[key] = group[i].getAttribute('id').slice(-3);
		}
	}
	
	// insertion de groupes de pages statiques
	for (let key in groupArray) {
		let p = document.createElement('p')
		let label = document.createElement('label')
		label.setAttribute('for',key);
		label.textContent = key;
		// ajout label
		p.appendChild(label)
		let input = document.createElement('input')
		input.setAttribute('id',key)
		input.setAttribute('type','checkbox')
		input.setAttribute('value',groupArray[key])
		
		// sont-elles déjà toutes séléctionnées
  let checkedIpt = true;
  let stateGroup  = groupArray[key].split("|");
  for(si=0;stateGroup.length > si ;si++ ){
    if(document.querySelector('#stat-'+stateGroup[si]+':not(:checked)')) checkedIpt =false;
  }
  if(checkedIpt === true)   input.setAttribute('checked','checked')
		// ajout input
		p.appendChild(input)
		// insertion du paragraphe
		fieldGroup.appendChild(p)
		// ajout listener sur input
		document.querySelector('#'+key).addEventListener(
		'change',
		function(){ 
			toggleSelGroup(this)
		},
		false)
	}
	
	function toggleSelGroup(el){
		let stats =el.value.split("|");
		for(stat=0;stats.length>stat;stat++){
			if(el.checked) {
				document.querySelector('#stat-'+stats[stat]).setAttribute('checked','checked')
			} 
			else {
				document.querySelector('#stat-'+stats[stat]).removeAttribute('checked')
			}
		}
	}
</script>