<?php if(!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			membersOnly
		*
		* @CMS required			PluXml 
		*
		* @version			1.0
		* @date				2025-01-01
		* @author 			Gcyrillus
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/
	class membersOnly extends plxPlugin {
		
		
		
		const BEGIN_CODE = '<?php' . PHP_EOL;
		const END_CODE = PHP_EOL . '?>';
		public $lang = ''; 
		public $statiques;
		public $categories;
		public $articles;
		
		
		public function __construct($default_lang) {
			# appel du constructeur de la classe plxPlugin (obligatoire)
			parent::__construct($default_lang);
			
			
			# droits pour accèder à la page admin.php du plugin
			$this->setAdminProfil(PROFIL_ADMIN, PROFIL_MANAGER);
			
			
			$this->statiques  = $this->getParam('statiques')  ==''   ?   '{}' : $this->getParam('statiques') ;
			$this->articles   = $this->getParam('articles')   ==''   ?   '{}' : $this->getParam('articles') ;
			$this->categories = $this->getParam('categories') ==''   ?   '{}' : $this->getParam('categories') ;
			
			
			# Declaration des hooks		
			$this->addHook('Index', 'Index');
			$this->addHook('SitemapBegin', 'Index');
			$this->addHook('AdminTopBottom','AdminTopBottom');
		}
		
		
		/**
			* Méthode qui affiche un message si le plugin n'a pas la langue du site dans sa traduction
			* @return	stdio
			* @author	Stephane F
		**/
		public function AdminTopBottom() {
			echo '<?php
			$file = PLX_PLUGINS."'.$this->plug['name'].'/lang/".$plxAdmin->aConf["default_lang"].".php";
			if(!file_exists($file)) {
			echo "<p class=\\"warning\\">'.basename(__DIR__).'<br />".sprintf("'.$this->getLang('L_LANG_UNAVAILABLE').'", $file)."</p>";
			plxMsg::Display();
			}
			?>';
		}
		
		/** 
			* Méthode Index
			* 
			* Descrition	:
			* @author		: TheCrok
			*
			* Filtre les pages,articles ou catégories non accessibles au public
			* 
		**/
		public function Index() {
			# filtrage depuis les paramêtres du plugin 
			
			$stats = $this->statiques ;
			echo self::BEGIN_CODE;
			?>
			$filter=<?= $stats ?>;
			foreach($plxMotor->aStats as $stat_num => $stat) {
				if(in_array($stat_num,$filter) && !isset($_SESSION['profil'])) unset($plxMotor->aStats[$stat_num]);
			}
			<?php
			echo self::END_CODE;
			
			
			$cats = $this->categories;	
			echo self::BEGIN_CODE;
			?>
			$filter=<?= $cats ?>;
			foreach($plxMotor->aCats as $cat_num => $infos) {
				if(in_array($cat_num,$filter) && !isset($_SESSION['profil'])) unset($plxMotor->aCats[$cat_num]);
			}
			<?php
			echo self::END_CODE;			
			
			$arts   = $this->articles ;
			echo self::BEGIN_CODE;
			?>
			$filter=<?= $arts ?>;
			foreach($plxMotor->plxGlob_arts->aFiles as $art_num => $file) {
				if(in_array($art_num,$filter) && !isset($_SESSION['profil'])) unset($plxMotor->plxGlob_arts->aFiles[$art_num]);
			}
			foreach($plxMotor->plxGlob_coms->aFiles as $com=>$comFile) {
				if(in_array(substr($comFile, 0, 4),$filter) && !isset($_SESSION['profil'])) unset($plxMotor->plxGlob_coms->aFiles[$com]);
			}
			<?php
			echo self::END_CODE;

		}
		
	}	